
{$APPTYPE GUI}{$MODE DELPHI}

program demo33;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Collision,GOGL_MetaBalls;

//const
 
//type
  
var 
  i:integer;
  timer:array[1..100]of integer;
  balls:array[1..4]of TMetaSphere;
  ball:TGLMetaball;
  
   
//{$R *.rc}
//{$R *.res}  


function SelectQuality(num:integer):integer;
begin    
  // si possono usare anche valori diversi compresi tra 10 e 100
  
  if num=7 then result:=MB_MaxQuality;      // Qualit massima
  if num=6 then result:=MB_VeryHighQuality; // Qualit molto alta
  if num=5 then result:=MB_HighQuality;     // Qualit alta
  if num=4 then result:=MB_MediumQuality;   // Qualit media
  if num=3 then result:=MB_BaseQuality;     // Qualit base
  if num=2 then result:=MB_LowQuality;      // Qualit bassa
  if num=1 then result:=MB_VeryLowQuality;  // Qualit molto bassa
  if num=0 then result:=MB_MinQuality;      // Qualit minima  
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
end;
begin 

  OpenGL_Texture();
  
  InitText(0,0,0,0);  

  with ball do
  begin   
    InitMetaball(MB_BaseQuality);

    balls[1]:=AddMetaball(glvector(0,0.2,0), 0.15);
    balls[2]:=AddMetaball(glvector(-0.5,0,0), 0.3);
    balls[3]:=AddMetaball(glvector(0.5,0,0), 0.2);
	balls[4]:=AddMetaball(glvector(0,0.6,0), 0.2);
  end;
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
 
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-0.2,-2);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(0,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0,0,10,0,0.1);     

  glDisable(GL_LIGHTING);  
  SmoothColorON; // effetto ombra sfumata
  
  with ball do
  begin   
   Draw([balls[1],balls[2],balls[3],balls[4]]); 
  
   if SetglKey('A')then SetPos(balls[1],VecSub(GetPos(balls[1]),glvector(0.025,0,0)));
   if SetglKey('D')then SetPos(balls[1],VecAdd(GetPos(balls[1]),glvector(0.025,0,0)));  
  
   if SetglKey('W')then SetPos(balls[1],VecAdd(GetPos(balls[1]),glvector(0,0.025,0)));  
   if SetglKey('S')then SetPos(balls[1],VecSub(GetPos(balls[1]),glvector(0,0.025,0)));   
  
   if SetglKey('R')then
   begin
    SetPos(balls[1],glvector(0,0.2,0));
    SetPos(balls[2],glvector(-0.5,0,0));
    SetPos(balls[3],glvector(0.5,0,0));
	SetPos(balls[4],glvector(0,0.6,0));
 	
	ball.InitMetaball(SelectQuality(4));
   end;  
  end;
  
  SmoothColorOFF;
  
  // selezione della qualit delle sfere
  if SetglKey('1')then ball.InitMetaball(SelectQuality(0));  
  if SetglKey('2')then ball.InitMetaball(SelectQuality(1)); 
  if SetglKey('3')then ball.InitMetaball(SelectQuality(2));
  if SetglKey('4')then ball.InitMetaball(SelectQuality(3));
  if SetglKey('5')then ball.InitMetaball(SelectQuality(4));
  if SetglKey('6')then ball.InitMetaball(SelectQuality(5));
  if SetglKey('7')then ball.InitMetaball(SelectQuality(6));  
  if SetglKey('8')then ball.InitMetaball(SelectQuality(7));
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Creazione di metaball', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
